## cascading.pipe.assembly
Class AverageBy.AverageFinal

    java.lang.Object
      cascading.operation.BaseOperation<AverageBy.AverageFinal.Context>
          cascading.pipe.assembly.AverageBy.AverageFinal

All Implemented Interfaces:
  Aggregator<AverageBy.AverageFinal.Context>, Operation<AverageBy.AverageFinal.Context>, Serializable

Enclosing class:
  AverageBy

    public static class AverageBy.AverageFinal

extends BaseOperation<AverageBy.AverageFinal.Context>
implements Aggregator<AverageBy.AverageFinal.Context>

Class AverageFinal is used to finalize the average operation on the Reduce side of the process. It must be used in tandem with a `AverageBy.AveragePartials` Functor.

See Also:
  Serialized Form

Nested Class Summary
`protected static class` `AverageBy.AverageFinal.Context` Class Context is used to hold intermediate values.

Field Summary

Fields inherited from class cascading.operation.BaseOperation
`fieldDeclaration, numArgs, trace`

Fields inherited from interface cascading.operation.Operation
`ANY`

Constructor Summary
`AverageBy.AverageFinal(Fields fieldDeclaration)` Constructs a new instance that returns the average of the values encountered in the given fieldDeclaration field name.

Method Summary
`void` `aggregate(FlowProcess flowProcess, AggregatorCall<AverageBy.AverageFinal.Context> aggregatorCall)` Method aggregate is called for each `TupleEntry` value in the current grouping.
`void` `complete(FlowProcess flowProcess, AggregatorCall<AverageBy.AverageFinal.Context> aggregatorCall)` Method complete will be issued last after every `TupleEntry` has been passed to the `Aggregator.aggregate(cascading.flow.FlowProcess, AggregatorCall)` method.
`void` `start(FlowProcess flowProcess, AggregatorCall<AverageBy.AverageFinal.Context> aggregatorCall)` Method start initializes the aggregation procedure and is called for every unique grouping.

Methods inherited from class cascading.operation.BaseOperation
`cleanup, equals, getFieldDeclaration, getNumArgs, getTrace, hashCode, isSafe, prepare, printOperationInternal, toString, toStringInternal`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface cascading.operation.Operation
`cleanup, getFieldDeclaration, getNumArgs, isSafe, prepare`

Constructor Detail

### AverageBy.AverageFinal

    public AverageBy.AverageFinal(Fields fieldDeclaration)

  Constructs a new instance that returns the average of the values encountered in the given fieldDeclaration field name.

  Parameters:
    `fieldDeclaration` - of type Fields

Method Detail

### start

    public void start(FlowProcess flowProcess,
                      AggregatorCall<AverageBy.AverageFinal.Context> aggregatorCall)

  Description copied from interface: `Aggregator`
  Method start initializes the aggregation procedure and is called for every unique grouping.

  The AggregatorCall context should be initialized here if necessary.

  The first time this method is called for a given 'process', the AggregatorCall context will be null. This method should set a new instance of the user defined context object. When the AggregatorCall context is not null, it is up to the developer to create a new instance, or 'recycle' the given instance. If recycled, it must be re-initialized to remove any previous state/values.

  For example, if a Map is used to hold the intermediate data for each subsequent `Aggregator.aggregate(cascading.flow.FlowProcess, AggregatorCall)` call, new HashMap() should be set on the AggregatorCall instance when `OperationCall.getContext()` is null. On the next grouping, start() will be called again, but this time with the old Map instance. In this case, map.clear() should be invoked before returning.

  Specified by:
    `start` in interface `Aggregator<AverageBy.AverageFinal.Context>`
  Parameters:
    `flowProcess` - of type FlowProcess
    `aggregatorCall` - of type AggregatorCall

### aggregate

    public void aggregate(FlowProcess flowProcess,
                          AggregatorCall<AverageBy.AverageFinal.Context> aggregatorCall)

  Description copied from interface: `Aggregator`
  Method aggregate is called for each `TupleEntry` value in the current grouping.

  TupleEntry entry, or entry.getTuple() should not be stored directly in the context. A copy of the tuple should be made via the `new Tuple( entry.getTuple() )` copy constructor.

  Specified by:
    `aggregate` in interface `Aggregator<AverageBy.AverageFinal.Context>`
  Parameters:
    `flowProcess` - of type FlowProcess
    `aggregatorCall` - of type AggregatorCall

### complete

    public void complete(FlowProcess flowProcess,
                         AggregatorCall<AverageBy.AverageFinal.Context> aggregatorCall)

  Description copied from interface: `Aggregator`
  Method complete will be issued last after every `TupleEntry` has been passed to the `Aggregator.aggregate(cascading.flow.FlowProcess, AggregatorCall)` method. Any final calculation should be completed here and passed to the outputCollector.

  Specified by:
    `complete` in interface `Aggregator<AverageBy.AverageFinal.Context>`
  Parameters:
    `flowProcess` - of type FlowProcess
    `aggregatorCall` - of type AggregatorCall

Copyright © 2007-2010 Concurrent, Inc. All Rights Reserved.